{ Intuition-Init und Spielfeld }
{ ---------------------------------------------------------------------- }
procedure setcolors;
var i:integer;
begin
   for i:=0 to 15 do SetRGBPalette(i,pal[i,0],pal[i,1],pal[i,2]);
end;

procedure darken;
var i:integer;
begin
   for i:=1 to 15 do setpalette(i,0);
end;

procedure lighten;
var i:integer;
begin
   for i:=1 to 15 do setpalette(i,i);
end;

{ ------------------------------------------------------------------------ }

procedure initimages;
var i,j,k,x,y,anz:word;
    fh           :file;
begin
{ Gesamtimage einlesen: }
   assign(fh,imafil);
   reset(fh,1);
   BlockRead(fh,ima[1],sizeof(image),anz);
   with ima[1] do begin
      anz:=ImageSize(1,1,width,height);
      if maxavail<(anz) then begin
         textmode(3);
         writeln('nicht gengend Speicherplatz fr Grafik');
         halt;
      end;
      Getmem(p_data,anz);
      BlockRead(fh,p_data^,anz,k);
      PutImage(0,0,p_data^,Normalput);
      FreeMem(p_data,anz);
   end;
   close(fh);

{ Teilimages: Maske Typ 1 (1-18) und Walkie (19-36) : }
   k:=0;
   for j:=0 to 1 do for i:=0 to 17 do begin
      inc(k);
      with ima[k] do begin
         x:=0; y:=0; width:=dx; height:=48; p_nextimage:=nil;
         anz:=Imagesize(1,1,width,height);
         GetMem(p_data,anz);
         GetImage(i*dx,j*height,pred(i*dx+width),pred(j*height+height),p_data^);
      end;
   end;

{ Teilimages: Sort re,li,ba (37-54) }
   for i:=0 to 17 do begin
      inc(k);
      with ima[k] do begin
         x:=0; y:=0; width:=dx; height:=dy; p_nextimage:=nil;
         anz:=Imagesize(1,1,width,height);
         GetMem(p_data,anz);
         GetImage(i*dx,104,pred(i*dx+width),pred(104+height),p_data^);
      end;
   end;

{ Teilimages: Maske re,li,ba (55-57) }
   for i:=0 to 2 do begin
      inc(k);
      with ima[k] do begin
         x:=0; y:=0; width:=dx; height:=dy; p_nextimage:=nil;
         anz:=Imagesize(1,1,width,height);
         GetMem(p_data,anz);
         GetImage(i*dx,136,pred(i*dx+width),pred(136+height),p_data^);
      end;
   end;

{ Teilimages: Path, Ko, Start, Mitte, Ende (58-62) }
   inc(k);
   with ima[k] do begin
      x:=0; y:=0; width:=dx; height:=dy+4; p_nextimage:=nil;
      anz:=Imagesize(1,1,width,height);
      GetMem(p_data,anz);
      GetImage(97,136,pred(97+width),pred(136+height),p_data^);
   end;
   inc(k);
   with ima[k] do begin
      x:=0; y:=0; width:=dx; height:=dy; p_nextimage:=nil;
      anz:=Imagesize(1,1,width,height);
      GetMem(p_data,anz);
      GetImage(160,136,pred(160+width),pred(136+height),p_data^);
   end;

   inc(k);
   with ima[k] do begin
      x:=0; y:=0; width:=16; height:=20; p_nextimage:=nil;
      anz:=Imagesize(1,1,width,height);
      GetMem(p_data,anz);
      GetImage(224,136,pred(224+width),pred(136+height),p_data^);
   end;
   inc(k);
   with ima[k] do begin
      x:=0; y:=0; width:=32; height:=20; p_nextimage:=nil;
      anz:=Imagesize(1,1,width,height);
      GetMem(p_data,anz);
      GetImage(240,136,pred(240+width),pred(136+height),p_data^);
   end;
   inc(k);
   with ima[k] do begin
      x:=0; y:=0; width:=20; height:=20; p_nextimage:=nil;
      anz:=Imagesize(1,1,width,height);
      GetMem(p_data,anz);
      GetImage(272,136,pred(272+width),pred(136+height),p_data^);
   end;

   putimage(0,256,ima[60].p_data^,normalput);
   putimage(16,256,ima[61].p_data^,normalput);
   putimage(48,256,ima[62].p_data^,normalput);
   with gima[1] do begin
      x:=0;
      y:=0;
      width:=68;
      height:=20;
      p_nextimage:=nil;
      anz:=Imagesize(1,1,width,height);
      GetMem(p_data,anz);
      GetImage(0,256,pred(width),pred(256+height),p_data^);
   end;

   putimage( 48,256,ima[61].p_data^,normalput);
   putimage( 80,256,ima[62].p_data^,normalput);
   with gima[2] do begin
      x:=0;
      y:=0;
      width:=100;
      height:=20;
      p_nextimage:=nil;
      anz:=Imagesize(1,1,width,height);
      GetMem(p_data,anz);
      GetImage(0,256,pred(width),pred(256+height),p_data^);
   end;

   for i:=0 to 2 do putimage(48+i*32,256,ima[61].p_data^,normalput);
   putimage(48+2*32,256,ima[62].p_data^,normalput);
   with gima[3] do begin
      x:=0;
      y:=0;
      width:=132;
      height:=20;
      p_nextimage:=nil;
      anz:=Imagesize(1,1,width,height);
      GetMem(p_data,anz);
      GetImage(0,256,pred(width),pred(256+height),p_data^);
   end;
   with gima[4] do begin
      x:=0;
      y:=0;
      width:=5*dx;
      height:=5*dy;
      p_nextimage:=nil;
      anz:=Imagesize(1,1,width,height);
      GetMem(p_data,anz);
   end;
   with ima[64] do begin
      x:=0;
      y:=0;
      width:=5*dx;
      height:=5*dy;
      p_nextimage:=nil;
      anz:=Imagesize(1,1,width,height);
      GetMem(p_data,anz);
   end;

   with ima[65] do begin
      x:=0;
      y:=0;
      width:=dx;
      height:=dy;
      p_nextimage:=nil;
      anz:=Imagesize(1,1,width,height);
      GetMem(p_data,anz);
      rectfill(0,0,width,height,3);
      GetImage(0,0,pred(width),pred(height),p_data^);
   end;
   with ima[66] do begin
      x:=0;
      y:=0;
      width:=dx;
      height:=dy;
      p_nextimage:=nil;
      anz:=Imagesize(1,1,width,height);
      GetMem(p_data,anz);
      putimage(0,0,ima[58].p_data^,normalput);
      GetImage(0,0,pred(width),pred(height),p_data^);
   end;


end;

{ ------------------------------------------------------------------------ }

procedure initgadgets;
var i,j,k:integer;
begin
   itext1[1].itext:='Level: ';
   itext1[2].itext:=' Neu   ';
   itext1[3].itext:=' Quit  ';
   for i:=1 to 3 do begin
      with itext1[i] do begin
         x:=5;
         y:=4;
         fpen:=4;
         bpen:=15;
         drmode:=jam1;
         p_nexttext:=addr(itext2[i]);
      end;
      with itext2[i] do begin
         x:=pred(itext1[i].x);
         y:=itext1[i].y;
         itext:=itext1[i].itext;
         fpen:=0;
         bpen:=15;
         drmode:=jam1;
         p_nexttext:=nil;
      end;
   end;

   with stringinfo[1] do begin
      x:=56; y:=4;
      if i=1 then maxlen:=32 else maxlen:=4;
      fpen:=1; bpen:=15;
      buff:='01';
      ubuff:='';
   end;

   for i:=1 to 3 do with igad[i] do begin
      id:=i;
      case i of
      1:    begin
               x:=16;
               y:=452;
               width:=320;
               height:=16;
               p_loimage:=addr(gima[2]);
            end;
      2..3: begin
               x:=i*72+340;
               y:=452;
               width:=72;
               height:=16;
               p_loimage:=addr(gima[1]);
            end;
      end;

      bpen:=-1;
      hibpen:=bpen;
      p_loborder:=nil;
      p_hiborder:=p_loborder;
      p_lointuitext:=addr(itext1[i]);
      p_hiintuitext:=p_lointuitext;
      p_hiimage:=p_loimage;
      if i>1 then gadgettyp:=boolgadget else gadgettyp:=strgadget;
      onoff:=false;
      active:=true;
      if i=1 then p_specialinfo:=addr(stringinfo[i]) else p_specialinfo:=nil;
      if i<3 then p_nextgadget:=addr(igad[succ(i)]) else p_nextgadget:=nil;
   end;
end;

{ ------------------------------------------------------------------- }

procedure buildscreen;
var i,j:integer;
    temp:string;
begin
   rectfill(0,0,639,479,3);
   putimage(16,8,ima[60].p_data^,normalput);
   for i:=1 to 18 do putimage(i*dx,8,ima[61].p_data^,normalput);
   putimage(608,8,ima[62].p_data^,normalput);
   setcolor(4);
   outtextxy(17,13,titel);
   setcolor(0);
   outtextxy(16,13,titel);

   PutImage(120,452,gima[2].p_data^,normalput);
   temp:='Zeit:';
   setcolor(4);
   outtextxy(129,456,temp);
   setcolor(0);
   outtextxy(128,456,temp);

   PutImage(224,452,gima[3].p_data^,normalput);
   temp:='Punkte:';
   setcolor(4);
   outtextxy(233,456,temp);
   setcolor(0);
   outtextxy(232,456,temp);

   PutImage(360,452,gima[2].p_data^,normalput);
   temp:='UJAs:';
   setcolor(4);
   outtextxy(369,456,temp);
   setcolor(0);
   outtextxy(368,456,temp);


   lighten;
   RefreshGadgets(addr(igad[1]));
end;
