program socksort;
{ Vers. 0.900: 31.03.96      Erstellen des Screens, der Gadgets und Images  }
{ Vers. 0.980: 12.04.96      Moves, Metamorphosen, Fallen, 10 Levels        }
{ Vers. 1.000: 14.04.96      HighScore, Restart, Image/Keystrg.-Optimierung }
{                            Ende-Bild }

{$M 8192,0,655360}

uses crt,dos,intuit,hiscore,graph,drivers,timer;

const titel =' o     Socken - Sortieren                UJA Vers. 1.000        TP6      o';
      code:string='123456ABCDEF #KU';
      imafil='ujasock.ima';  levelfil='ujasock.l'; hscfile='ujasock.hsc';
      dx=32; dy=32; xmax=16; ymax=12; ox=32; oy=32; zx=560; zy=12; smax=32;
      pal:array[0..15,0..2] of integer=
      (( 0, 0, 0),( 7,14,15),(17,42,21),(16,12,12),
       (42,14, 0),(32, 0,42),(42,31, 0),(41,41,29),
       (15,31,28),(25, 0,63),(37,63, 0),(26,63,50),
       (63,21, 1),(63,21,49),(63,52, 0),(63,63,42));

type feld = array[-1..xmax+2,-1..ymax+2] of integer;
     sorte= record
               farbe,x,y,xx,yy,relibako:integer;
               {nicht vorhanden=0, re=1, li=2, ba=3, ko=4}
            end;
     sorten=array[0..smax] of sorte;

var ok,ende,fertig,timeron,ujaweg,weg,saund:boolean;
    ch0,ch1                  :char;
    temp,ue                  :string;
    g,mx,my,x,y,sm,level,zeit,zeita,z,timing,kox,koy,nuja,ux,uy,ux0,uy0,snr:integer;
    punkte,p0,pmax           :longint;
    f0,f1                    :feld;
    s0,s1                    :sorten;
    ima           :array[1..72] of image;
    gima          :array[1..4] of Image;
    igad          :array[1..4] of Gadget;
    itext1,itext2 :array[1..4] of IntuiText;
    stringinfo    :array[1..1] of StrInfo;
    ho,mi,se,tic  :word;
    hsc           :HighScore;


{ ------------------------------------------------------------------------ }
{$i sockintu.inc}
{ ------------------------------------------------------------------------ }
function updattime(ho,mo,so,po:word):integer;
var h,m,s,p:word;
    temp   :string;
    sec    :integer;
begin
gettime(h,m,s,p);
p:=p-po; if p<0 then begin dec(s); p:=p+100; end;
s:=s-so; if s<0 then begin dec(m); s:=s+60; end;
m:=m-mo; if m<0 then begin dec(h); m:=m+60; end;
h:=h-ho;
sec:=60*(h*60+m)+s;
updattime:=sec;
end;

procedure updatzeit(t:integer);
var temp:string;
begin
   str(t:4,temp);
   rectfill(166,456,205,464,15);
   setcolor(4);
   outtextxy(167,456,temp);
   setcolor(0);
   outtextxy(166,456,temp);
end;

procedure updatuja(u:integer);
var temp:string;
begin
   str(u:2,temp);
   rectfill(410,456,432,464,15);
   setcolor(4);
   outtextxy(411,456,temp);
   setcolor(0);
   outtextxy(410,456,temp);
end;


{ ------------------------------------------------------------------------ }

procedure updatpunkte(t:longint);
var temp:string;
begin
   str(t:7,temp);
   rectfill(290,456,346,464,15);
   setcolor(4);
   outtextxy(291,456,temp);
   setcolor(0);
   outtextxy(290,456,temp);
end;

{ ------------------------------------------------------------------------ }

procedure drawelement(x,y,nr:integer);
begin
   if nr<>13 then putimage(x*dx+ox,y*dy+oy,ima[58].p_data^,normalput);
   if nr in [1..12] then begin { Sorten }
      if nr<7 then putimage(x*dx+ox,y*dy+oy,ima[55].p_data^,andput)
              else putimage(x*dx+ox,y*dy+oy,ima[56].p_data^,andput);
      putimage(x*dx+ox,y*dy+oy,ima[nr+36].p_data^,orput);
   end;
   if nr=15 then putimage(x*dx+ox,y*dy+oy,ima[nr+44].p_data^,normalput);
   if nr=16 then begin
      putimage(x*dx+ox,y*dy+oy,ima[58].p_data^,normalput);
      putimage(x*dx+ox,y*dy+oy-16,ima[1].p_data^,andput);
      putimage(x*dx+ox,y*dy+oy-16,ima[19].p_data^,orput);
   end;
end;

{ ------------------------------------------------------------------------ }

procedure laden(var f1:feld; var zeit,level:integer; var ue:string;
                var pmax:longint);
const t:array[1..ymax] of string=(
' ',
'       #######',
'  ######D#5###',
'  #1#   #   ##',
'  #F#   3   4E',
'  #D#   ######',
'  #6#   #4#  B',
'  #A#####C#  2',
'  ###   ####UK',
' ',
' ',
' ');

var fh  :text;
    temp:string;
    i,j:integer;
    fil:boolean;
begin
   for i:=-1 to xmax+2 do for j:=-1 to ymax+2 do f1[i,j]:=13;
   str(level:2,temp);
   if temp[1]=' ' then temp[1]:='0';
   temp:=levelfil+temp;
   pmax:=0;

{$i-}
   assign(fh,temp);
   reset(fh);
   fil:=ioresult=0;
   if not fil then level:=0;
   if fil then readln(fh,ue)    else ue:=' * I N T E R N *';
   if fil then readln(fh,zeit)  else zeit:=300;
   for j:=1 to ymax do begin
      if fil then readln(fh,temp) else temp:=t[j];
      for i:=1 to length(temp) do begin
         f1[i,j]:=pos(temp[i],code);
         if temp[i]='K' then begin
            kox:=i;
            koy:=j;
         end;
         if temp[i]='U' then begin
            ux:=i;
            uy:=j;
         end;
         if f1[i,j]<7 then pmax:=pmax+50;
      end;
   end;
   if fil then close(fh);
{$i+}
   rectfill(ox+dx,oy+dy-16,ox+succ(xmax)*dx+4,oy+succ(ymax)*dy+4,3);
   for i:=1 to xmax do for j:=1 to ymax do Drawelement(i,j,f1[i,j]);
   rectfill(48,13,319,20,15);
   setcolor(4);
   outtextxy(49,13,ue);
   setcolor(0);
   outtextxy(48,13,ue);
   str(level:2,temp);
   stringinfo[1].buff:=temp;
   RefreshGadgets(addr(igad[1]));
   fertig:=false;
end;

{$i sockmove.inc}

procedure initgame;
begin
      punkte:=0;
      p0:=punkte;
      level:=1;
      laden(f1,zeit,level,ue,pmax);
      ux0:=ux;
      uy0:=uy;
      nuja:=3;
      f0:=f1;
      f1[ux,uy]:=14;
      updatzeit(zeit);
      updatpunkte(punkte+p0);
      updatuja(nuja);
      gettime(ho,mi,se,tic);
      timeron:=true;
      showmouse;
      z:=zeit;
      zeita:=0;
      weg:=false;
while keypressed do ch0:=readkey;
ch0:='.';
end;





procedure inituja;
begin
ux:=ux0;
uy:=uy0;
dec(nuja);
updatuja(nuja);
weg:=nuja<1;
putimage(ux*dx+ox,uy*dx+oy-16,ima[7].p_data^,andput);
if nuja>0 then putimage(ux*dx+ox,uy*dx+oy-16,ima[25].p_data^,orput);
if saund then sound(50);
delay1(1000);
nosound;
if weg then begin
   punkte:=p0+punkte;
   updathighscore(punkte,hscfile,hsc,ox+5*dx,oy+3*dy,20,7,11,0,6);
end;
while keypressed do ch0:=readkey;
ch0:='.';
end;


procedure cleanup;
var i:integer; anz:word;
begin
   for i:=1 to 66 do with ima[i] do begin
      if p_data<>nil then begin
         anz:=Imagesize(1,1,width,height);
         Freemem(p_data,anz);
      end;
   end;  
    for i:=1 to 4 do with gima[i] do begin
      if p_data<>nil then begin
         anz:=Imagesize(1,1,width,height);
         Freemem(p_data,anz);
      end;
   end;
end;




procedure endebild;
const filnam1='uja1.ima'; filnam2='uja2.ima';
var ima1     :image;
    fh       :file;
    anz      :word;
begin
darken;
hidemouse;
rectfill(ox+16,oy+16,ox+succ(xmax)*dx+16,oy+ymax*dy+16,8);
rectfill(0,448,639,479,3);
assign(fh,filnam1);
reset(fh,1);
BlockRead(fh,ima1,sizeof(image),anz);
with ima1 do begin
   anz:=ImageSize(1,1,width,height);
   getmem(p_data,anz);
   BlockRead(fh,p_data^,anz,anz);
end;
close(fh);
PutImage(ox+dx,oy+dy,ima1.p_data^,normalput);
freemem(ima1.p_data,anz);
assign(fh,filnam2);
reset(fh,1);
BlockRead(fh,ima1,sizeof(image),anz);
with ima1 do begin
   anz:=ImageSize(1,1,width,height);
   getmem(p_data,anz);
   BlockRead(fh,p_data^,anz,anz);
end;
close(fh);
PutImage(ox+dx+280,oy+dy,ima1.p_data^,normalput);
freemem(ima1.p_data,anz);
lighten;
while keypressed do ch0:=readkey;
ch0:=readkey;
end;




{ ====================================================================== }

begin
   saund:=true;
   if paramcount>0 then begin
      temp:=paramstr(1);
      if (temp[1] in ['Q','q']) then saund:=false;
   end;
   for x:=1 to 72 do ima[x].p_data:=nil;
   timing:=50;
   initscreen(ok);
   if ok then begin
      setcolors;
      darken;
      loadhighscore(hscfile,hsc);
      initimages;
      initgadgets;
      buildscreen;
      initgame;
      while not ende do begin
         zeit:=updattime(ho,mi,se,tic);
         if zeit<>zeita then begin
            zeita:=zeit;
            updatzeit(z-zeit);
            ujaweg:=z<zeit;
            if ujaweg then begin
               gettime(ho,mi,se,tic);
               background(ux,uy,f1);
               getimage(2*dx,512+dy,3*dx,512+3*dy,ima[64].p_data^);
               putimage(ux*dx+ox,uy*dy-dy+oy,ima[64].p_data^,normalput);
               inituja;
            end;
         end;
         ch0:='.';
         while keypressed do ch0:=readkey;
         if ch0<>'.' then begin
            hidemouse;
            case ch0 of
                   #72: if not weg then moveup(ux,uy,f1,ujaweg);
                   #75: if not weg then moveleft(ux,uy,f1,ujaweg);
                   #77: if not weg then moveright(ux,uy,f1,ujaweg);
                   #80: if not weg then movedown(ux,uy,f1,ujaweg);
            #27,'Q','q': ende:=true;
            '+','-':     begin
                            if weg then initgame;
                            if ch0='+' then if level<99 then inc(level);
                            if ch0='-' then if level>1 then dec(level);
                            rectfill(0,oy+dy,639,oy+succ(ymax)*dy,3);
                            laden(f1,zeit,level,ue,pmax);
                            punkte:=0;
                            ux0:=ux;
                            uy0:=uy;
                            f0:=f1;
                            f1[ux,uy]:=14;
                            gettime(ho,mi,se,tic);
                            z:=zeit;
                            updatpunkte(p0);
                         end;
            'N','n':     begin
                            if weg then initgame;
                            ux:=ux0;
                            uy:=uy0;
                            f1:=f0;
                            rectfill(0,oy,639,oy+succ(ymax)*dy,3);
                            for x:=1 to xmax do for y:=1 to ymax do drawelement(x,y,f1[x,y]);
                            f1[ux,uy]:=14;
                            punkte:=0;
                         end;
            'S','s':     saund:=not saund;
            end;
            fertig:=punkte=pmax;
            if ujaweg then inituja;
         end;
         showmouse;
         getgadget(addr(igad[1]),g,mx,my);
         if g>0 then begin
            hidemouse;
            case g of
               1: begin   { Level }
                     if weg then initgame;
                     getstring(igad[g]);
                     val(stringinfo[g].buff,level,x);
                     if level<1 then level:=1;
                     if level>99 then level:=99;
                     str(level:2,stringinfo[g].buff);
                     DrawGadget(addr(igad[g]));
                     rectfill(0,oy+dy,639,oy+succ(ymax)*dy,3);
                     laden(f1,zeit,level,ue,pmax);
                     gettime(ho,mi,se,tic);
                     f0:=f1;
                     ux0:=ux;
                     uy0:=uy;
                     punkte:=0;
                     f1[ux,uy]:=14;
                  end;
               2: begin { alt }
                     if weg then initgame;
                     ux:=ux0;
                     uy:=uy0;
                     f1:=f0;
                     rectfill(0,oy,639,oy+succ(ymax)*dy,3);
                     for x:=1 to xmax do for y:=1 to ymax do drawelement(x,y,f1[x,y]);
                     f1[ux,uy]:=14;
                     punkte:=0;
                     updatpunkte(p0);
                  end;
               3: ende:=true;
            end;
            showmouse;
         end;
         if fertig then begin
            p0:=p0+punkte+1000;
            updatpunkte(p0);
            delay(1000);
            inc(level);
            laden(f1,zeit,level,ue,pmax);
            while keypressed do ch0:=readkey;
            ch0:=readkey;
            ende:=level=0;
            gettime(ho,mi,se,tic);
            z:=zeit;
            f0:=f1;
            ux0:=ux;
            uy0:=uy;
            punkte:=0;
            f1[ux,uy]:=14;
         end;
      end;
      cleanup;
      if level=0 then Endebild;  { alle Levels durch }
   end;
   textmode(3);
end.
