program sockedit;
{ Vers. 0.900: 13.03.96      Erstellen des Screens, der Gadgets und Images }
{ Vers. 1.000: 14.03.96      feddich! Aber noch nicht getestet             }
{              31.03.96      feddich und getestet                          }

{$M 16384,0,655360}

uses crt,dos,intuit,graph,drivers;

const titel =' o     Socken - Editor              UJA Vers. 1.000          TP6         o';
      code:string='123456ABCDEF #KU';
      imafil='ujasock.ima';  levelfil='ujasock.l';
      dx=32; dy=32; xmax=16; ymax=12; ox=0; oy=12; zx=560; zy=12; smax=32;
      pal:array[0..15,0..2] of integer=
      (( 0, 0, 0),( 7,14,15),(17,42,21),( 0,31,31),
       (42,14, 0),(32, 0,42),(42,31, 0),(41,41,29),
       (15,31,28),(25, 0,63),(37,63, 0),(26,63,50),
       (63,21, 1),(63,21,49),(63,52, 0),(63,63,42));

type feld = array[0..succ(xmax),0..succ(ymax)] of integer;
     sorte= record
               farbe,x,y,xx,yy,relibako:integer;
               {nicht vorhanden=0, re=1, li=2, ba=3, ko=4}
            end;
     sorten=array[0..smax] of sorte;

var ok,ende,fertig           :boolean;
    ch0,ch1                  :char;
    temp,ue                  :string;
    g,mx,my,x,y,sm,level,zeit,kox,koy,ux,uy,snr:integer;
    f0,f1                    :feld;
    s0,s1                    :sorten;
    ima           :array[1..63] of image;
    gima          :array[1..4] of Image;
    igad          :array[1..12] of Gadget;
    itext1,itext2 :array[1..12] of IntuiText;
    stringinfo    :array[1..3] of StrInfo;
    ibord1,ibord2 :Border;
    xy            :Koords;

{ ------------------------------------------------------------------------ }

procedure setcolors;
var i:integer;
begin
   for i:=0 to 15 do SetRGBPalette(i,pal[i,0],pal[i,1],pal[i,2]);
end;

procedure darken;
var i:integer;
begin
   for i:=1 to 15 do setpalette(i,0);
end;

procedure lighten;
var i:integer;
begin
   for i:=1 to 15 do setpalette(i,i);
end;

{ ------------------------------------------------------------------------ }

procedure initimages;
var i,j,k,x,y,anz:word;
    fh           :file;
begin
{ Gesamtimage einlesen: }
   assign(fh,imafil);
   reset(fh,1);
   BlockRead(fh,ima[1],sizeof(image),anz);
   with ima[1] do begin
      anz:=ImageSize(1,1,width,height);
      if maxavail<(anz) then begin
         textmode(3);
         writeln('nicht gengend Speicherplatz fr Grafik');
         halt;
      end;
      Getmem(p_data,anz);
      BlockRead(fh,p_data^,anz,k);
      PutImage(0,0,p_data^,Normalput);
      FreeMem(p_data,anz);
   end;
   close(fh);

{ Teilimages: Maske Typ 1 (1-18) und Walkie (19-36) : }
   k:=0;
   for j:=0 to 1 do for i:=0 to 17 do begin
      inc(k);
      with ima[k] do begin
         x:=0; y:=0; width:=dx; height:=48; p_nextimage:=nil;
         anz:=Imagesize(1,1,width,height);
         GetMem(p_data,anz);
         GetImage(i*dx,j*height,pred(i*dx+width),pred(j*height+height),p_data^);
      end;
   end;

{ Teilimages: Sort re,li,ba (37-54) }
   for i:=0 to 17 do begin
      inc(k);
      with ima[k] do begin
         x:=0; y:=0; width:=dx; height:=dy; p_nextimage:=nil;
         anz:=Imagesize(1,1,width,height);
         GetMem(p_data,anz);
         GetImage(i*dx,104,pred(i*dx+width),pred(104+height),p_data^);
      end;
   end;

{ Teilimages: Maske re,li,ba (55-57) }
   for i:=0 to 2 do begin
      inc(k);
      with ima[k] do begin
         x:=0; y:=0; width:=dx; height:=dy; p_nextimage:=nil;
         anz:=Imagesize(1,1,width,height);
         GetMem(p_data,anz);
         GetImage(i*dx,136,pred(i*dx+width),pred(136+height),p_data^);
      end;
   end;

{ Teilimages: Path, Ko, Start, Mitte, Ende (58-62) }
   inc(k);
   with ima[k] do begin
      x:=0; y:=0; width:=dx+2; height:=dy+2; p_nextimage:=nil;
      anz:=Imagesize(1,1,width,height);
      GetMem(p_data,anz);
      GetImage(96,136,pred(96+width),pred(136+height),p_data^);
   end;
   inc(k);
   with ima[k] do begin
      x:=0; y:=0; width:=dx+2; height:=dy+2; p_nextimage:=nil;
      anz:=Imagesize(1,1,width,height);
      GetMem(p_data,anz);
      GetImage(160,136,pred(160+width),pred(136+height),p_data^);
   end;

   inc(k);
   with ima[k] do begin
      x:=0; y:=0; width:=16; height:=20; p_nextimage:=nil;
      anz:=Imagesize(1,1,width,height);
      GetMem(p_data,anz);
      GetImage(224,136,pred(224+width),pred(136+height),p_data^);
   end;
   inc(k);
   with ima[k] do begin
      x:=0; y:=0; width:=32; height:=20; p_nextimage:=nil;
      anz:=Imagesize(1,1,width,height);
      GetMem(p_data,anz);
      GetImage(240,136,pred(240+width),pred(136+height),p_data^);
   end;
   inc(k);
   with ima[k] do begin
      x:=0; y:=0; width:=20; height:=20; p_nextimage:=nil;
      anz:=Imagesize(1,1,width,height);
      GetMem(p_data,anz);
      GetImage(272,136,pred(272+width),pred(136+height),p_data^);
   end;

   putimage(0,256,ima[60].p_data^,normalput);
   putimage(16,256,ima[61].p_data^,normalput);
   putimage(48,256,ima[62].p_data^,normalput);
   with gima[1] do begin
      x:=0;
      y:=0;
      width:=68;
      height:=20;
      p_nextimage:=nil;
      anz:=Imagesize(1,1,width,height);
      GetMem(p_data,anz);
      GetImage(0,256,pred(width),pred(256+height),p_data^);
   end;

   putimage( 48,256,ima[61].p_data^,normalput);
   putimage( 80,256,ima[62].p_data^,normalput);
   with gima[2] do begin
      x:=0;
      y:=0;
      width:=100;
      height:=20;
      p_nextimage:=nil;
      anz:=Imagesize(1,1,width,height);
      GetMem(p_data,anz);
      GetImage(0,256,pred(width),pred(256+height),p_data^);
   end;

   for i:=0 to 7 do putimage(48+i*32,256,ima[61].p_data^,normalput);
   putimage(48+8*32,256,ima[62].p_data^,normalput);
   with gima[3] do begin
      x:=0;
      y:=0;
      width:=324;
      height:=20;
      p_nextimage:=nil;
      anz:=Imagesize(1,1,width,height);
      GetMem(p_data,anz);
      GetImage(0,256,pred(width),pred(256+height),p_data^);
   end;
end;

{ ------------------------------------------------------------------------ }

procedure initgadgets;
var i,j,k:integer;
begin
   itext1[1].itext:='Lname: ';
   itext1[2].itext:='Level: ';
   itext1[3].itext:=' Zeit: ';
   itext1[4].itext:=' Laden ';
   itext1[5].itext:='Sichern';
   itext1[6].itext:='  Neu  ';
   itext1[7].itext:='  Alt  ';
   itext1[8].itext:='  Quit ';
   for i:=1 to 8 do begin
      with itext1[i] do begin
         x:=5;
         y:=4;
         fpen:=4;
         bpen:=15;
         drmode:=jam1;
         p_nexttext:=addr(itext2[i]);
      end;
      with itext2[i] do begin
         x:=pred(itext1[i].x);
         y:=itext1[i].y;
         itext:=itext1[i].itext;
         fpen:=0;
         bpen:=15;
         drmode:=jam1;
         p_nexttext:=nil;
      end;
   end;

   xy[0]:=0; xy[1]:=0; xy[2]:=pred(dx); xy[3]:=0; xy[4]:=pred(dx);
   xy[5]:=pred(dy); xy[6]:=0; xy[7]:=pred(dy); xy[8]:=0; xy[9]:=0;
   with ibord1 do begin
      x:=0; y:=0; fpen:=0; bpen:=0; drmode:=jam1; ecken:=5;
      p_ecken:=addr(xy);
      p_nextborder:=nil;
   end;
   with ibord2 do begin
      x:=0; y:=0; fpen:=12; bpen:=0; drmode:=jam1; ecken:=5;
      p_ecken:=addr(xy);
      p_nextborder:=nil;
   end;

   for i:=1 to 3 do with stringinfo[i] do begin
      x:=56; y:=4;
      if i=1 then maxlen:=32 else maxlen:=5;
      fpen:=1; bpen:=15;
      case i of
      1: buff:='Ei, wo sind sie denn?';
      2: buff:='01';
      3: buff:='300';
      end;
      ubuff:='';
   end;

   for i:=1 to 10 do with igad[i] do begin
      id:=i;
      case i of
      1:    begin
               x:=22;
               y:=432;
               width:=320;
               height:=16;
               p_loimage:=addr(gima[3]);
            end;
      2..3: begin
               x:=i*112-212;
               y:=452;
               width:=120;
               height:=16;
               p_loimage:=addr(gima[2]);
            end;
      4..8: begin
               x:=i*80-80;
               y:=452;
               width:=72;
               height:=16;
               p_loimage:=addr(gima[1]);
            end;
      9:    begin
               x:=zx;
               y:=zy+dy;
               width:=2*dx;
               height:=12*dy;
               p_loimage:=nil;
            end;
      10:    begin
               x:=ox+dx;
               y:=oy+dy;
               width:=xmax*dx;
               height:=ymax*dy;
               p_loimage:=nil;
            end;
      end;
      bpen:=-1;
      hibpen:=bpen;
      p_loborder:=nil;
      p_hiborder:=p_loborder;
      if i<9 then p_lointuitext:=addr(itext1[i]) else p_lointuitext:=nil;
      p_hiintuitext:=p_lointuitext;
      p_hiimage:=p_loimage;
      if i>3 then gadgettyp:=boolgadget else gadgettyp:=strgadget;
      onoff:=false;
      active:=true;
      if i<4 then p_specialinfo:=addr(stringinfo[i]) else p_specialinfo:=nil;
      if i<10 then p_nextgadget:=addr(igad[succ(i)]) else p_nextgadget:=nil;
   end;
end;

{ ------------------------------------------------------------------- }

procedure buildscreen;
var i,j:integer;
begin
   rectfill(0,0,639,479,3);
   putimage(16,8,ima[60].p_data^,normalput);
   for i:=1 to 18 do putimage(i*dx,8,ima[61].p_data^,normalput);
   putimage(608,8,ima[62].p_data^,normalput);
   setcolor(4);
   outtextxy(17,13,titel);
   setcolor(0);
   outtextxy(16,13,titel);
   lighten;
   setcolor(0);
   for i:=1 to succ(xmax) do line(ox+i*dx,oy+dy,ox+i*dx,oy+succ(ymax)*dy);
   for i:=1 to succ(ymax) do line(ox+dx,oy+i*dy,ox+succ(xmax)*dx,oy+i*dy);
   for i:=1 to 12 do begin
      if i<7 then putimage(zx,i*dy+oy,ima[55].p_data^,andput)
              else putimage(zx,i*dy+oy,ima[56].p_data^,andput);
      putimage(zx,i*dy+oy,ima[i+36].p_data^,orput);
      DrawBorder(zx,i*dy+oy,addr(ibord1));
   end;
   putimage(zx+dx,2*dy+oy,ima[58].p_data^,normalput);
   putimage(zx+dx,3*dy+oy,ima[59].p_data^,normalput);
   putimage(zx+dx,4*dy+oy+4,ima[ 1].p_data^,andput);
   putimage(zx+dx,4*dy+oy+4,ima[19].p_data^,orput);
   for i:=1 to 4 do DrawBorder(zx+dx,i*dy+oy,addr(ibord1));
   RefreshGadgets(addr(igad[1]));
end;

{ ------------------------------------------------------------------------ }

procedure drawelement(x,y,nr:integer);
begin
   if nr in [1..12] then begin { Sorten }
      if f1[x,y]<>14 then begin
         putimage(x*dx+ox,y*dy+oy,ima[58].p_data^,normalput);
         if f1[x,y]=15 then kox:=0;
      end;
      if nr<7 then putimage(x*dx+ox,y*dy+oy,ima[55].p_data^,andput)
              else putimage(x*dx+ox,y*dy+oy,ima[56].p_data^,andput);
      putimage(x*dx+ox,y*dy+oy,ima[nr+36].p_data^,orput);
   end;
   if nr=13 then rectfill(x*dx+ox,y*dy+oy,x*dx+ox+pred(dx),y*dy+oy+pred(dy),3);
   if (nr>13) and (nr<16)
   then putimage(x*dx+ox,y*dy+oy,ima[nr+44].p_data^,normalput);
   if nr=16 then begin
      putimage(x*dx+ox,y*dy+oy,ima[58].p_data^,normalput);
      putimage(x*dx+ox,y*dy+oy-16,ima[1].p_data^,andput);
      putimage(x*dx+ox,y*dy+oy-16,ima[19].p_data^,orput);
   end;
   Drawborder(x*dx+ox,y*dy+oy,addr(ibord1));
end;

{ ------------------------------------------------------------------------ }

procedure loeschelement(x,y,nr:integer);
begin
   rectfill(x*dx+ox,y*dy+oy,x*dx+ox+pred(dx),y*dy+oy+pred(dy),3);
   if nr=16 then begin
      rectfill(succ(x*dx+ox),y*dy+oy,pred(x*dx+ox+pred(dx)),y*dy+oy-16,3);
      if y>1 then Drawelement(x,pred(y),f1[x,pred(y)]);
   end;
   Drawborder(x*dx+ox,y*dy+oy,addr(ibord1));
end;

{ ------------------------------------------------------------------------ }

procedure markiere(nr:integer; onoff:boolean);
var x,y:integer;
begin
   x:=pred(nr) div 12;
   y:=succ(pred(nr) mod 12);
   if onoff then drawborder(x*dx+zx,y*dy+zy,addr(ibord2))
            else drawborder(x*dx+zx,y*dy+zy,addr(ibord1));
end;

{ ------------------------------------------------------------------------ }

procedure initfeld(var f:feld);
var i,j:integer;
begin
   for i:=1 to xmax do for j:=1 to ymax do begin
      f[i,j]:=13;
      loeschelement(i,j,f[i,j]);
   end;
end;

{ ----------------------------------------------------------------------- }

procedure checkit(var f1:feld; var temp:string; var ok:boolean);
var i,j,k:integer;
    count:array[1..16] of integer;
begin
   ok:=false;
   for i:=1 to 16 do count[i]:=0;
   for i:=1 to xmax do for j:=1 to ymax do inc(count[f1[i,j]]);
   for i:=1 to 12 do if count[i]>0 then ok:=true;     { mind. 1 Paerchen }
   if not ok then temp:='Keine Socken auf der Terasse!';
   for i:=1 to 6 do if count[i]<>count[i+6] then begin
      ok:=false;
      temp:='Ungepaarte Socken-Nr. ['+chr(48+i)+']';
   end;
   if ok then begin
      ok:=count[15]=1;
      if not ok then temp:='kein Krbchen zum Sammeln!';
   end;
   if ok then begin
      ok:=count[16]=1;
      if not ok then temp:='... und wer soll die Arbeit tun?';
   end;
end;

{ ------------------------------------------------------------------------ }

procedure speichern(var f1:feld; var zeit,level:integer; var ue:string);
var fh:text;
    temp:string;
    i,j:integer;
begin
   str(level:2,temp);
   if temp[1]=' ' then temp[1]:='0';
   temp:=levelfil+temp;
   assign(fh,temp);
   rewrite(fh);
   writeln(fh,ue);
   writeln(fh,zeit);
   for j:=1 to ymax do begin
      temp:='';
      for i:=1 to xmax do temp:=temp+code[f1[i,j]];
      writeln(fh,temp);
   end;
   close(fh);
end;

{ ------------------------------------------------------------------------ }

procedure laden(var f1:feld; var zeit,level:integer; var ue:string);
var fh:text;
    temp:string;
    i,j:integer;
begin
   str(level:2,temp);
   if temp[1]=' ' then temp[1]:='0';
   temp:=levelfil+temp;
   assign(fh,temp);
   reset(fh);
   readln(fh,ue);
   readln(fh,zeit);
   for j:=1 to ymax do begin
      readln(fh,temp);
      for i:=1 to xmax do f1[i,j]:=pos(temp[i],code);
   end;
   close(fh);

   rectfill(ox+dx,oy+dy-16,ox+succ(xmax)*dx,oy+succ(ymax)*dy,3);
   for i:=1 to xmax do for j:=1 to ymax do Drawelement(i,j,f1[i,j]);
   str(level:2,temp);
   stringinfo[2].buff:=temp;
   str(zeit:3,temp);
   stringinfo[3].buff:=temp;
   stringinfo[1].buff:=ue;
   RefreshGadgets(addr(igad[1]));

end;

{ ====================================================================== }

begin
   initscreen(ok);
   if ok then begin
      setcolors;
      darken;
      initimages;
      initgadgets;
      buildscreen;
      initfeld(f1);
      f0:=f1;
      level:=1;
      zeit:=300;
      snr:=13;
      kox:=0;
      ux:=0;
      ue:=stringinfo[2].buff;
      markiere(snr,true);
      ende:=false;
      showmouse;
      while not ende do begin
         delay(50);
         if keypressed then begin
            hidemouse;
            ch0:=readkey;
            case ch0 of
            #27,'Q','q': ende:=true;
            '+','-':     begin
                            if ch0='+' then if level<99 then inc(level);
                            if ch0='-' then if level>1 then dec(level);
                            with stringinfo[1] do begin
                               ubuff:=buff;
                               str(level:2,buff);
                               if buff[1]=' ' then buff[1]:='0';
                            end;
                            DrawGadget(addr(igad[1]));
                            { levelladen,  f0=alt, f1=neu}
                         end;
            'A','a':     begin
                            f1:=f0;
                            for x:=1 to xmax do for y:=1 to ymax do loeschelement(x,y,f1[x,y]);
                            for x:=1 to xmax do for y:=1 to ymax do drawelement(x,y,f1[x,y]);
                         end;
            'N','n':     begin
                            initfeld(f0); 
                            f1:=f0;
                         end;
            'Z','z':     begin
                            { Level abspeichern }
                         end;
            end;
            showmouse;
         end else begin
            getgadget(addr(igad[1]),g,mx,my);
            if g>0 then begin
               hidemouse;
               case g of
               1: begin  { Ueberschrift }
                     getstring(igad[g]);
                     ue:=stringinfo[g].buff;
                     DrawGadget(addr(igad[g]));
                  end;
               2: begin   { Level }
                     getstring(igad[g]);
                     val(stringinfo[g].buff,level,x);
                     if level<1 then level:=1;
                     if level>99 then level:=99;
                     str(level:2,stringinfo[g].buff);
                     DrawGadget(addr(igad[g]));
                  end;
               3: begin   { Zeitlimit }
                     getstring(igad[g]);
                     val(stringinfo[g].buff,zeit,x);
                     if zeit<60 then zeit:=60;
                     if zeit>9999 then zeit:=9999;
                     str(zeit:3,stringinfo[g].buff);
                     DrawGadget(addr(igad[g]));
                  end;
               4: begin { laden }
                     f0:=f1;
                     laden(f1,zeit,level,ue);
                  end;
               5: begin
                     checkit(f1,temp,ok);
                     if ok then begin
                        speichern(f1,zeit,level,ue);
                        temp:='   - alles paletti! - ';
                     end;
                     rectfill(352,436,611,447,4);
                     setcolor(15);
                     outtextxy(356,438,temp);
                  end;
               6: begin { neu }
                     f0:=f1;
                     initfeld(f1);
                  end;
               7: begin { alt }
                     f1:=f0;
                     for x:=1 to xmax do for y:=1 to ymax do loeschelement(x,y,f1[x,y]);
                     for x:=1 to xmax do for y:=1 to ymax do drawelement(x,y,f1[x,y]);
                  end;
               8: ende:=true;
               9: begin
                     markiere(snr,false);
                     snr:=((mx-zx) div dx)*12+(my-zy) div dy;
                     if snr>16 then snr:=16;
                     markiere(snr,true);
                  end;
              10: begin
                     x:=(mx-ox) div dx;
                     y:=(my-oy) div dy;
                     if snr<15 then begin
                        f1[x,y]:=snr;
                        DrawElement(x,y,f1[x,y]);
                     end;
                     if snr=15 then begin
                        if kox>0 then begin
                           loeschelement(kox,koy,f1[kox,koy]);
                           f1[kox,koy]:=13;
                        end;
                        kox:=x;
                        koy:=y;
                        drawelement(kox,koy,snr);
                        f1[kox,koy]:=snr;
                     end;
                     if snr=16 then begin
                        if ux>0 then begin
                           loeschelement(ux,uy,f1[ux,uy]);
                           f1[ux,uy]:=13;
                        end;
                        ux:=x;
                        uy:=y;
                        loeschelement(ux,uy,f1[ux,uy]);
                        Drawelement(ux,uy,snr);
                        f1[x,y]:=snr;
                     end;
                  end;
               end;

               showmouse;
            end;
         end;
      end;
   end;
   textmode(3);
end.

